<template id="total-stats">
  <div class="box box-warning">
    <div class="box-header with-border">
      <h3 class="box-title">Total stats</h3>
      <div class="box-tools pull-right">
        <button
          v-if="!show_table"
          @click="showAndHideComponents(true,false,false)"
          type="button"
          class="btn show-table-btn"
        >
          <i class="fa fa-table"></i>
        </button>
        <button
          v-if="!show_line_chart"
          @click="showAndHideComponents(false,true,false)"
          type="button"
          class="btn show-chart-btn"
        >
          <i class="fa fa-chart-line"></i>
        </button>
        <button
          v-if="!show_bar_chart"
          @click="showAndHideComponents(false,false,true)"
          type="button"
          class="btn show-chart-btn"
        >
          <i class="fa fa-chart-bar"></i>
        </button>
      </div>
    </div>
    <div class="box-body">
      <div class="chart">
        <div class="card">
          <div class="card-body">
            <div class="chart">
              <LineChart v-if="show_line_chart" :chartData="chartData" :options="optionsLine"></LineChart>
              <BarChart v-if="show_bar_chart" :chartData="chartData" :options="optionsBar"></BarChart>
            </div>
            <div v-if="show_table && tableStats" class="table-area">
              <table class="table table-hover table-striped">
                <tbody>
                  <tr>
                    <th>Date</th>
                    <th>Amount, €</th>
                  </tr>

                  <tr v-for="result in tableStats.data" :key="result.date">
                    <td>{{ result.date}}</td>
                    <td>{{ result.sum }} €</td>
                  </tr>
                </tbody>
              </table>
            </div>
            <div v-if="show_table" class="card-footer">
              <pagination
                class="paginator"
                :data="tableStats"
                @pagination-change-page="getTableStats"
              ></pagination>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

  <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.13.0/moment.min.js"></script>
<script src="https://chartjs-plugin-datalabels.netlify.com/guide/positioning.html#clamping"></script>

<script>
import moment from "moment";
import LineChart from "./LineChart.vue";
import BarChart from "./BarChart.vue";

export default {
  props: ["date_interval", "stats", "interval"],

  components: {
    LineChart,
    BarChart
  },
  data: function() {
    return {
      chartData: null,
      optionsLine: null,
      optionsBar: null,
      tableStats: {},
      show_table: false,
      show_line_chart: true,
      show_bar_chart: false
    };
  },

  created: function() {
    this.setChartValues();
  },

  watch: {
    date_interval: function() {
      this.show_table = false;
      this.setChartValues();
    },

    stats: function() {
      this.setChartValues();
    }
  },

  methods: {
    showAndHideComponents(table, line, bar) {
      if (table) {
        this.show_table = true;
        this.getTableStats();
      } else if (line) {
        this.show_table = false;
        this.show_bar_chart = false;
        this.show_line_chart = true;
      }

      if (bar) {
        this.show_table = false;
        this.show_bar_chart = true;
        this.show_line_chart = false;
      }
    },

    getTableStats(page = 1) {
      let uri = "api/total-stats/" + this.interval + "?paginate=1";

      axios
        .get(uri, {
          params: {
            page: page
          }
        })
        .then(response => {
          this.tableStats = response.data.results;
        });
    },

    setChartValues: function() {
      let labels = this.stats.results.map(list => {
        return list.date;
      });

      let amounts = this.stats.results.map(list => {
        return list.sum;
      });
      this.assignChartValues(labels, amounts);
    },

    assignChartValues: function(labels, amounts) {
      this.chartData = {
        labels: labels,
        datasets: [
          {
            label: "Transaction sum, €",
            backgroundColor: "#a7d975",
            borderColor: Fire.getRandomColorHex(labels.length),
            fill: true,
            data: amounts,
            datalabels: {
              labels: {
                title: null
              }
            }
          }
        ]
      };
      this.optionsLine = {
        tooltips: {
          callbacks: {
            label: function(tooltipItem, data) {
              return data["datasets"][0]["data"][tooltipItem["index"]] + " €";
            }
          }
        },
        scales: {
          yAxes: [
            {
              scaleLabel: {
                display: true,
                labelString: "Amount, €"
              }
            }
          ],
          xAxes: [
            {
              scaleLabel: {
                display: true,
                labelString: "dates"
              }
            }
          ]
        },

        legend: {
          display: false,
          labels: {
            boxWidth: 0
          },

          onClick: e => e.stopPropagation()
        }
      };

      this.optionsBar = Object.assign({}, this.optionsLine);

      this.optionsBar.scales.yAxes[0].ticks = {
        beginAtZero: true
      };
    }
  }
};
</script>